<?php

function tcd_template_meta_box() {
  add_meta_box(
    'page_meta_box1',//ID of meta box
    __('Page template setting', 'tcd-w'),//label
    'show_tcd_template_meta_box',//callback function
    'page',// post type
    'normal',// context
    'high'// priority
  );
}
add_action('add_meta_boxes', 'tcd_template_meta_box');

function show_tcd_template_meta_box() {
  global $post;
  $options =  get_desing_plus_option();

  //テンプレートのタイプ
  $page_tcd_template_type =
		array(
			'name' => __('Page template type', 'tcd-w'),
			'id' => 'page_tcd_template_type',
			'type' => 'radio',
      'std' => 'type1',
			'options' => array(
				array('name' => __('Normal template', 'tcd-w'), 'value' => 'type1', 'img' => 'template_type1.jpg'),
				array('name' => __('No side content', 'tcd-w'), 'value' => 'type2', 'img' => 'template_type2.jpg'),
				array('name' => __('Template1', 'tcd-w'), 'value' => 'type3', 'img' => 'template_type3.jpg'),
				array('name' => __('Template2', 'tcd-w'), 'value' => 'type4', 'img' => 'template_type4.jpg'),
				array('name' => __('Template3', 'tcd-w'), 'value' => 'type5', 'img' => 'template_type5.jpg'),
			)
    );
  $page_tcd_template_type_meta = get_post_meta($post->ID, 'page_tcd_template_type', true);

  // テンプレート1---------------------------------------------------------------------

  //1列目
  $type1_row1_headline = array( 'name' => __('Headline for first row', 'tcd-w'), 'desc' => '', 'id' => 'type1_row1_headline', 'type' => 'textarea', 'std' => '' );
  $type1_row1_headline_meta = esc_html(get_post_meta($post->ID, 'type1_row1_headline', true));
  $type1_row1_desc = array( 'name' => __('Content for first row', 'tcd-w'), 'desc' => '', 'id' => 'type1_row1_desc', 'type' => 'textarea', 'std' => '' );
  $type1_row1_desc_meta = get_post_meta($post->ID, 'type1_row1_desc', true);

  //３列目
  $type1_row3_headline = array( 'name' => __('Headline for third row', 'tcd-w'), 'desc' => '', 'id' => 'type1_row3_headline', 'type' => 'textarea', 'std' => '' );
  $type1_row3_headline_meta = esc_html(get_post_meta($post->ID, 'type1_row3_headline', true));
  $type1_row3_desc1 = array( 'name' => __('Content for third row first column', 'tcd-w'), 'desc' => '', 'id' => 'type1_row3_desc1', 'type' => 'textarea', 'std' => '' );
  $type1_row3_desc1_meta = get_post_meta($post->ID, 'type1_row3_desc1', true);
  $type1_row3_desc2 = array( 'name' => __('Content for third row second column', 'tcd-w'), 'desc' => '', 'id' => 'type1_row3_desc2', 'type' => 'textarea', 'std' => '' );
  $type1_row3_desc2_meta = get_post_meta($post->ID, 'type1_row3_desc2', true);

  //５列目
  $type1_row5_headline1 = array( 'name' => __('Headline for fifth row first column', 'tcd-w'), 'desc' => '', 'id' => 'type1_row5_headline1', 'type' => 'textarea', 'std' => '' );
  $type1_row5_headline1_meta = esc_html(get_post_meta($post->ID, 'type1_row5_headline1', true));
  $type1_row5_headline2 = array( 'name' => __('Headline for fifth row second column', 'tcd-w'), 'desc' => '', 'id' => 'type1_row5_headline2', 'type' => 'textarea', 'std' => '' );
  $type1_row5_headline2_meta = esc_html(get_post_meta($post->ID, 'type1_row5_headline2', true));
  $type1_row5_desc1 = array( 'name' => __('Content for fifth row first column', 'tcd-w'), 'desc' => '', 'id' => 'type1_row5_desc1', 'type' => 'textarea', 'std' => '' );
  $type1_row5_desc1_meta = get_post_meta($post->ID, 'type1_row5_desc1', true);
  $type1_row5_desc2 = array( 'name' => __('Content for fifth row second column', 'tcd-w'), 'desc' => '', 'id' => 'type1_row5_desc2', 'type' => 'textarea', 'std' => '' );
  $type1_row5_desc2_meta = get_post_meta($post->ID, 'type1_row5_desc2', true);

  // テンプレート2---------------------------------------------------------------------

  //1列目
  $type2_row1_headline = array( 'name' => __('Headline for first row', 'tcd-w'), 'desc' => '', 'id' => 'type2_row1_headline', 'type' => 'textarea', 'std' => '' );
  $type2_row1_headline_meta = esc_html(get_post_meta($post->ID, 'type2_row1_headline', true));
  $type2_row1_desc = array( 'name' => __('Content for first row', 'tcd-w'), 'desc' => '', 'id' => 'type2_row1_desc', 'type' => 'textarea', 'std' => '' );
  $type2_row1_desc_meta = get_post_meta($post->ID, 'type2_row1_desc', true);

  //住所
  $type2_address = array( 'name' => __('Address', 'tcd-w'), 'desc' => '', 'id' => 'type2_address', 'type' => 'textarea', 'std' => '' );
  $type2_address_meta = get_post_meta($post->ID, 'type2_address', true);

  //地図のタイプ
  $map_type =
		array(
			'name' => __('Google map type', 'tcd-w'),
			'id' => 'map_type',
			'type' => 'radio',
      'std' => 'type1',
			'options' => array(
				array('name' => __('Use Google map iframe code', 'tcd-w'), 'value' => 'type1'),
             array('name' => __('Use <a href="https://wordpress.org/plugins/tcd-google-maps/" target="_blank">TCD Google Maps plugin</a>', 'tcd-w'), 'value' => 'type2')
			)
    );
  $map_type_meta = get_post_meta($post->ID, 'map_type', true);

  //Google map iframe
  $type2_map = array( 'name' => __('Google map iframe code', 'tcd-w'), 'desc' => '', 'id' => 'type2_map', 'type' => 'textarea', 'std' => '' );
  $type2_map_meta = get_post_meta($post->ID, 'type2_map', true);

  //Google map plugin
  $type2_map2 = array( 'name' => __('TCD Google Maps plugin short code', 'tcd-w'), 'desc' => __('Copy and paste TCD Google Maps plugin short code here', 'tcd-w'), 'id' => 'type2_map2', 'type' => 'textarea', 'std' => '' );
  $type2_map2_meta = get_post_meta($post->ID, 'type2_map2', true);

  //地図の情報
  $type2_info1 = array( 'name' => __('Map information', 'tcd-w'), 'desc' => '', 'id' => 'type2_info1', 'type' => 'textarea', 'std' => '' );
  $type2_info1_meta = get_post_meta($post->ID, 'type2_info1', true);
  $type2_info2 = array( 'name' => __('Map information', 'tcd-w'), 'desc' => '', 'id' => 'type2_info2', 'type' => 'textarea', 'std' => '' );
  $type2_info2_meta = get_post_meta($post->ID, 'type2_info2', true);
  $type2_info3 = array( 'name' => __('Map information', 'tcd-w'), 'desc' => '', 'id' => 'type2_info3', 'type' => 'textarea', 'std' => '' );
  $type2_info3_meta = get_post_meta($post->ID, 'type2_info3', true);

  // テンプレート3---------------------------------------------------------------------

  //1列目
  $type3_row1_headline = array( 'name' => __('Headline for first menu', 'tcd-w'), 'desc' => '', 'id' => 'type3_row1_headline', 'type' => 'textarea', 'std' => '' );
  $type3_row1_headline_meta = esc_html(get_post_meta($post->ID, 'type3_row1_headline', true));

  $type3_row1_desc = array( 'name' => __('Description for first menu', 'tcd-w'), 'desc' => '', 'id' => 'type3_row1_desc', 'type' => 'textarea', 'std' => '' );
  $type3_row1_desc_meta = get_post_meta($post->ID, 'type3_row1_desc', true);

  //2列目
  $type3_row2_headline = array( 'name' => __('Headline for second menu', 'tcd-w'), 'desc' => '', 'id' => 'type3_row2_headline', 'type' => 'textarea', 'std' => '' );
  $type3_row2_headline_meta = esc_html(get_post_meta($post->ID, 'type3_row2_headline', true));

  $type3_row2_desc = array( 'name' => __('Description for second menu', 'tcd-w'), 'desc' => '', 'id' => 'type3_row2_desc', 'type' => 'textarea', 'std' => '' );
  $type3_row2_desc_meta = get_post_meta($post->ID, 'type3_row2_desc', true);

  //メニュー１のタイプ
  $menu1_type =
		array(
			'name' => __('Menu1 layout type', 'tcd-w'),
			'id' => 'menu1_type',
			'type' => 'radio',
      'std' => 'type1',
			'options' => array(
				array('name' => __('Vertical layout', 'tcd-w'), 'value' => 'type1'),
				array('name' => __('Horizontal layout', 'tcd-w'), 'value' => 'type2')
			)
    );
  $menu1_type_meta = get_post_meta($post->ID, 'menu1_type', true);

  //メニュー２のタイプ
  $menu2_type =
		array(
			'name' => __('Menu2 layout type', 'tcd-w'),
			'id' => 'menu2_type',
			'type' => 'radio',
      'std' => 'type1',
			'options' => array(
				array('name' => __('Vertical layout', 'tcd-w'), 'value' => 'type1'),
				array('name' => __('Horizontal layout', 'tcd-w'), 'value' => 'type2')
			)
    );
  $menu2_type_meta = get_post_meta($post->ID, 'menu2_type', true);

  // ---------------------------------------------------------------------

  echo '<input type="hidden" name="custom_fields_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';

  //テンプレートの選択 ***********************************************************************************************************************************************************************************
  echo '<dl class="ml_custom_fields_select" id="ml_custom_fields_box1">';

  echo '<dt class="label"><label for="' , $page_tcd_template_type['id'] , '">' , $page_tcd_template_type['name'] , '</label></dt>';
  echo '<dd class="content"><ul class="radio template cf">';
	foreach ($page_tcd_template_type['options'] as $page_tcd_template_type_option) {
    if($page_tcd_template_type_option['value'] == 'type1' || $page_tcd_template_type_option['value'] == 'type2') {
      echo '<li><label', ( ( empty($page_tcd_template_type_meta) && $page_tcd_template_type_option['value'] == 'type1' ) || $page_tcd_template_type_meta == $page_tcd_template_type_option['value'] ) ? ' class="active"' : '' ,'><input type="radio" id ="template_', $page_tcd_template_type_option['value'], '" name="', $page_tcd_template_type['id'], '" value="', $page_tcd_template_type_option['value'], '"', ($page_tcd_template_type_meta == $page_tcd_template_type_option['value'] || $page_tcd_template_type['std'] == $page_tcd_template_type_option['value']) ? ' checked="checked"' : '', ' />', $page_tcd_template_type_option['name'] , '</label></li>';
    } else {
      echo '<li><label', ( ( empty($page_tcd_template_type_meta) && $page_tcd_template_type_option['value'] == 'type1' ) || $page_tcd_template_type_meta == $page_tcd_template_type_option['value'] ) ? ' class="active"' : '' ,'><input type="radio" id ="template_', $page_tcd_template_type_option['value'], '" name="', $page_tcd_template_type['id'], '" value="', $page_tcd_template_type_option['value'], '"', ($page_tcd_template_type_meta == $page_tcd_template_type_option['value'] || $page_tcd_template_type['std'] == $page_tcd_template_type_option['value']) ? ' checked="checked"' : '', ' />', $page_tcd_template_type_option['name'] , '</label><a href="' , bloginfo('template_url') , '/admin/img/' ,  $page_tcd_template_type_option['img'] , '" class="fancybox" rel="group1" title="' , $page_tcd_template_type_option['name'] , '">' , __('View image', 'tcd-w') ,'</a></li>';
    }
  }
  echo '</ul></dd>';

  echo '</dl>';

  if(empty($page_tcd_template_type_meta) || $page_tcd_template_type_meta == 'type1' || $page_tcd_template_type_meta == 'type2') { } else {
    echo '<style>#postdivrich { display:none; }</style>';
  };

  if($page_tcd_template_type_meta != 'type5') {
    echo '<style>#ml_repeater_menu1, #ml_repeater_menu2 { display:none; }</style>';
  } else {
    echo '<style>#ml_repeater_menu1, #ml_repeater_menu2 { display:block; }</style>';
  }


  //テンプレート1 ***************************************************************************************************************************************************************************************

  echo '<dl class="ml_custom_fields type2" id="ml_custom_fields_box3"' , ( $page_tcd_template_type_meta == 'type3' ) ? ' style="display:block;"' : ' style="display:none;"' , '>';

  //見出し
  echo '<dt class="headline"><label>' , __('Template1', 'tcd-w') , '</label></dt>';

  //１段目
  echo '<dt class="label"><label for="' , $type1_row1_headline['id'] , '">' , $type1_row1_headline['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type1_row1_headline['id'], '" id="', $type1_row1_headline['id'], '" cols="60" rows="2">', $type1_row1_headline_meta ? $type1_row1_headline_meta : $type1_row1_headline['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label"><label for="' , $type1_row1_desc['id'] , '">' , $type1_row1_desc['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type1_row1_desc['id'], '" id="', $type1_row1_desc['id'], '" cols="60" rows="3">', $type1_row1_desc_meta ? $type1_row1_desc_meta : $type1_row1_desc['std'], '</textarea>';
  echo '</dd>';

  //２段目
  echo '<dt class="label"><label>' , __('Image for second row', 'tcd-w') ,'</label></dt>';
  echo '<dd class="content"><p class="desc">' , __('Recommend image size. Width:1150px Height:300px', 'tcd-w') , '</p>';
    mlcf_media_form('type1_row2_image1', __('Image', 'tcd-w'));
  echo '</dd>';

  //３段目
  echo '<dt class="label"><label for="' , $type1_row3_headline['id'] , '">' , $type1_row3_headline['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type1_row3_headline['id'], '" id="', $type1_row3_headline['id'], '" cols="60" rows="2">', $type1_row3_headline_meta ? $type1_row3_headline_meta : $type1_row3_headline['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label"><label for="' , $type1_row3_desc1['id'] , '">' , $type1_row3_desc1['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type1_row3_desc1['id'], '" id="', $type1_row3_desc1['id'], '" cols="60" rows="4">', $type1_row3_desc1_meta ? $type1_row3_desc1_meta : $type1_row3_desc1['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label"><label for="' , $type1_row3_desc2['id'] , '">' , $type1_row3_desc2['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type1_row3_desc2['id'], '" id="', $type1_row3_desc2['id'], '" cols="60" rows="4">', $type1_row3_desc2_meta ? $type1_row3_desc2_meta : $type1_row3_desc2['std'], '</textarea>';
  echo '</dd>';

  //４段目
  echo '<dt class="label"><label>' , __('Image for fourth row first column', 'tcd-w') ,'</label></dt>';
  echo '<dd class="content"><p class="desc">' , __('Recommend image size. Width:384px Height:320px', 'tcd-w') , '</p>';
    mlcf_media_form('type1_row4_image1', __('Image', 'tcd-w'));
  echo '</dd>';

  echo '<dt class="label"><label>' , __('Image for fourth row second column', 'tcd-w') ,'</label></dt>';
  echo '<dd class="content"><p class="desc">' , __('Recommend image size. Width:384px Height:320px', 'tcd-w') , '</p>';
    mlcf_media_form('type1_row4_image2', __('Image', 'tcd-w'));
  echo '</dd>';

  echo '<dt class="label"><label>' , __('Image for fourth row third column', 'tcd-w') ,'</label></dt>';
  echo '<dd class="content"><p class="desc">' , __('Recommend image size. Width:384px Height:320px', 'tcd-w') , '</p>';
    mlcf_media_form('type1_row4_image3', __('Image', 'tcd-w'));
  echo '</dd>';

  //５段目
  echo '<dt class="label"><label for="' , $type1_row5_headline1['id'] , '">' , $type1_row5_headline1['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type1_row5_headline1['id'], '" id="', $type1_row5_headline1['id'], '" cols="60" rows="2">', $type1_row5_headline1_meta ? $type1_row5_headline1_meta : $type1_row5_headline1['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label"><label for="' , $type1_row5_desc1['id'] , '">' , $type1_row5_desc1['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type1_row5_desc1['id'], '" id="', $type1_row5_desc1['id'], '" cols="60" rows="2">', $type1_row5_desc1_meta ? $type1_row5_desc1_meta : $type1_row5_desc1['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label"><label>' , __('Image for fifth row first column', 'tcd-w') ,'</label></dt>';
  echo '<dd class="content"><p class="desc">' , __('Recommend image size. Width:550px Height:320px', 'tcd-w') , '</p>';
    mlcf_media_form('type1_row5_image1', __('Image', 'tcd-w'));
  echo '</dd>';

  echo '<dt class="label"><label for="' , $type1_row5_headline2['id'] , '">' , $type1_row5_headline2['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type1_row5_headline2['id'], '" id="', $type1_row5_headline2['id'], '" cols="60" rows="2">', $type1_row5_headline2_meta ? $type1_row5_headline2_meta : $type1_row5_headline2['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label"><label for="' , $type1_row5_desc2['id'] , '">' , $type1_row5_desc2['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type1_row5_desc2['id'], '" id="', $type1_row5_desc2['id'], '" cols="60" rows="2">', $type1_row5_desc2_meta ? $type1_row5_desc2_meta : $type1_row5_desc2['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label"><label>' , __('Image for fifth row second column', 'tcd-w') ,'</label></dt>';
  echo '<dd class="content"><p class="desc">' , __('Recommend image size. Width:550px Height:320px', 'tcd-w') , '</p>';
    mlcf_media_form('type1_row5_image2', __('Image', 'tcd-w'));
  echo '</dd>';

  echo '</dl>';

  //テンプレート2 ***************************************************************************************************************************************************************************************

  echo '<dl class="ml_custom_fields type2" id="ml_custom_fields_box4"' , ( $page_tcd_template_type_meta == 'type4' ) ? ' style="display:block;"' : ' style="display:none;"' , '>';

  //見出し
  echo '<dt class="headline"><label>' , __('Template2', 'tcd-w') , '</label></dt>';

  //１段目
  echo '<dt class="label"><label for="' , $type2_row1_headline['id'] , '">' , $type2_row1_headline['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type2_row1_headline['id'], '" id="', $type2_row1_headline['id'], '" cols="60" rows="2">', $type2_row1_headline_meta ? $type2_row1_headline_meta : $type2_row1_headline['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label"><label for="' , $type2_row1_desc['id'] , '">' , $type2_row1_desc['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type2_row1_desc['id'], '" id="', $type2_row1_desc['id'], '" cols="60" rows="3">', $type2_row1_desc_meta ? $type2_row1_desc_meta : $type2_row1_desc['std'], '</textarea>';
  echo '</dd>';

  //２段目
  echo '<dt class="label"><label>' , __('Image for second row', 'tcd-w') ,'</label></dt>';
  echo '<dd class="content"><p class="desc">' , __('Recommend image size. Width:1200px Height:330px', 'tcd-w') , '</p>';
    mlcf_media_form('type2_row2_image', __('Image', 'tcd-w'));
  echo '</dd>';

  //３段目
  echo '<dt class="label"><label>' , __('Image for third row first column', 'tcd-w') ,'</label></dt>';
  echo '<dd class="content"><p class="desc">' , __('Recommend image size. Width:380px Height:320px', 'tcd-w') , '</p>';
    mlcf_media_form('type2_row3_image1', __('Image', 'tcd-w'));
  echo '</dd>';

  echo '<dt class="label"><label>' , __('Image for third row second column', 'tcd-w') ,'</label></dt>';
  echo '<dd class="content"><p class="desc">' , __('Recommend image size. Width:380px Height:320px', 'tcd-w') , '</p>';
    mlcf_media_form('type2_row3_image2', __('Image', 'tcd-w'));
  echo '</dd>';

  echo '<dt class="label"><label>' , __('Image for third row third column', 'tcd-w') ,'</label></dt>';
  echo '<dd class="content"><p class="desc">' , __('Recommend image size. Width:380px Height:320px', 'tcd-w') , '</p>';
    mlcf_media_form('type2_row3_image3', __('Image', 'tcd-w'));
  echo '</dd>';

  //４段目
  echo '<dt class="label"><label>' , __('Logo image for fourth row', 'tcd-w') ,'</label></dt>';
  echo '<dd class="content">';
    mlcf_media_form('type2_row4_image', __('Image', 'tcd-w'));
  echo '</dd>';

  echo '<dt class="label"><label for="' , $type2_address['id'] , '">' , $type2_address['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type2_address['id'], '" id="', $type2_address['id'], '" cols="60" rows="3">', $type2_address_meta ? $type2_address_meta : $type2_address['std'], '</textarea>';
  echo '</dd>';

  //５段目 Google map
  echo '<dt class="label"><label for="' , $map_type['id'] , '">' , $map_type['name'] , '</label></dt>';
  echo '<dd class="content"><ul class="radio template cf">';
	foreach ($map_type['options'] as $map_type_option) {
    echo '<li><label', ( ( empty($map_type_meta) && $map_type_option['value'] == 'type1' ) || $map_type_meta == $map_type_option['value'] ) ? ' class="active"' : '' ,'><input type="radio" id ="map_type_', $map_type_option['value'], '" name="', $map_type['id'], '" value="', $map_type_option['value'], '"', ($map_type_meta == $map_type_option['value'] || $map_type['std'] == $map_type_option['value']) ? ' checked="checked"' : '', ' />', $map_type_option['name'] , '</label></li>';
  }
  echo '</ul></dd>';

  echo '<dt class="label google_map_code_area"', ( $map_type_meta == 'type1' ) ? ' style="display:block;"' : ' style="display:none;"' , '>';
  echo '<label for="' , $type2_map['id'] , '">' , $type2_map['name'] , '</label></dt>';
  echo '<dd class="content google_map_code_area"', ( $map_type_meta == 'type1' ) ? ' style="display:block;"' : ' style="display:none;"' , '>';
  echo '<textarea name="', $type2_map['id'], '" id="', $type2_map['id'], '" cols="60" rows="5">', $type2_map_meta ? $type2_map_meta : $type2_map['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label google_map_code_area2"', ( $map_type_meta == 'type2' ) ? ' style="display:block;"' : ' style="display:none;"' , '>';
  echo '<label for="' , $type2_map2['id'] , '">' , $type2_map2['name'] , '</label></dt>';
  echo '<dd class="content google_map_code_area2"', ( $map_type_meta == 'type2' ) ? ' style="display:block;"' : ' style="display:none;"' , '>';
  echo '<p class="desc">', $type2_map2['desc'] ,'</p>';
  echo '<textarea name="', $type2_map2['id'], '" id="', $type2_map2['id'], '" cols="60" rows="5">', $type2_map2_meta ? $type2_map2_meta : $type2_map2['std'], '</textarea>';
  echo '</dd>';

  //６段目
  echo '<dt class="label"><label for="' , $type2_info1['id'] , '">' , $type2_info1['name'] , '1</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type2_info1['id'], '" id="', $type2_info1['id'], '" cols="60" rows="5">', $type2_info1_meta ? $type2_info1_meta : $type2_info1['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label"><label for="' , $type2_info2['id'] , '">' , $type2_info2['name'] , '2</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type2_info2['id'], '" id="', $type2_info2['id'], '" cols="60" rows="5">', $type2_info2_meta ? $type2_info2_meta : $type2_info2['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label"><label for="' , $type2_info3['id'] , '">' , $type2_info3['name'] , '3</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type2_info3['id'], '" id="', $type2_info3['id'], '" cols="60" rows="5">', $type2_info3_meta ? $type2_info3_meta : $type2_info3['std'], '</textarea>';
  echo '</dd>';

  echo '</dl>';

  //テンプレート3 ***************************************************************************************************************************************************************************************

  echo '<dl class="ml_custom_fields type2" id="ml_custom_fields_box5"' , ( $page_tcd_template_type_meta == 'type5' ) ? ' style="display:block;"' : ' style="display:none;"' , '>';

  //見出し
  echo '<dt class="headline"><label>' , __('Template3', 'tcd-w') , '</label></dt>';

  //１段目
  echo '<dd class="message">' , __('Please register menu data from menu setting field of this page.', 'tcd-w') , '</dd>';

  //１段目
  echo '<dt class="label"><label for="' , $type3_row1_headline['id'] , '">' , $type3_row1_headline['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type3_row1_headline['id'], '" id="', $type3_row1_headline['id'], '" cols="60" rows="2">', $type3_row1_headline_meta ? $type3_row1_headline_meta : $type3_row1_headline['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label"><label for="' , $type3_row1_desc['id'] , '">' , $type3_row1_desc['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type3_row1_desc['id'], '" id="', $type3_row1_desc['id'], '" cols="60" rows="2">', $type3_row1_desc_meta ? $type3_row1_desc_meta : $type3_row1_desc['std'], '</textarea>';
  echo '</dd>';

  //メニュー１のデザイン
  echo '<dt class="label"><label for="' , $menu1_type['id'] , '">' , $menu1_type['name'] , '</label></dt>';
  echo '<dd class="content"><ul class="radio cf">';
	foreach ($menu1_type['options'] as $menu1_type_option) {
   echo '<li><label', ( ( empty($menu1_type_meta) && $menu1_type_option['value'] == 'type1' ) || $menu1_type_meta == $menu1_type_option['value'] ) ? ' class="active"' : '' ,'><input type="radio" name="', $menu1_type['id'], '" value="', $menu1_type_option['value'], '"', ($menu1_type_meta == $menu1_type_option['value'] || $menu1_type['std'] == $menu1_type_option['value']) ? ' checked="checked"' : '', ' />', $menu1_type_option['name'] , '</label></li>';
  }
  echo '</ul></dd>';

  //２段目
  echo '<dt class="label"><label>' , __('Image for second menu', 'tcd-w') ,'</label></dt>';
  echo '<dd class="content"><p class="desc">' , __('Recommend image size. Width:1150px Height:300px', 'tcd-w') , '</p>';
    mlcf_media_form('type3_row2_image', __('Image', 'tcd-w'));
  echo '</dd>';

  echo '<dt class="label"><label for="' , $type3_row2_headline['id'] , '">' , $type3_row2_headline['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type3_row2_headline['id'], '" id="', $type3_row2_headline['id'], '" cols="60" rows="2">', $type3_row2_headline_meta ? $type3_row2_headline_meta : $type3_row2_headline['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label"><label for="' , $type3_row2_desc['id'] , '">' , $type3_row2_desc['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $type3_row2_desc['id'], '" id="', $type3_row2_desc['id'], '" cols="60" rows="2">', $type3_row2_desc_meta ? $type3_row2_desc_meta : $type3_row2_desc['std'], '</textarea>';
  echo '</dd>';

  //メニュー２のデザイン
  echo '<dt class="label"><label for="' , $menu2_type['id'] , '">' , $menu2_type['name'] , '</label></dt>';
  echo '<dd class="content"><ul class="radio cf">';
	foreach ($menu2_type['options'] as $menu2_type_option) {
   echo '<li><label', ( ( empty($menu2_type_meta) && $menu2_type_option['value'] == 'type1' ) || $menu2_type_meta == $menu2_type_option['value'] ) ? ' class="active"' : '' ,'><input type="radio" name="', $menu2_type['id'], '" value="', $menu2_type_option['value'], '"', ($menu2_type_meta == $menu2_type_option['value'] || $menu2_type['std'] == $menu2_type_option['value']) ? ' checked="checked"' : '', ' />', $menu2_type_option['name'] , '</label></li>';
  }
  echo '</ul></dd>';

  echo '</dl>';

}

function save_custom_fields_meta_box( $post_id ) {

  // verify nonce
  if (!isset($_POST['custom_fields_meta_box_nonce']) || !wp_verify_nonce($_POST['custom_fields_meta_box_nonce'], basename(__FILE__))) {
    return $post_id;
  }

  // check autosave
  if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
    return $post_id;
  }

  // check permissions
  if ('page' == $_POST['post_type']) {
    if (!current_user_can('edit_page', $post_id)) {
      return $post_id;
    }
  } elseif (!current_user_can('edit_post', $post_id)) {
      return $post_id;
  }

  // save or delete
  $cf_keys = array('page_tcd_template_type', 'type1_row1_headline' , 'type1_row1_desc', 'type1_row3_headline', 'type1_row3_desc1', 'type1_row3_desc2', 'type1_row5_headline1', 'type1_row5_headline2', 'type1_row5_desc1', 'type1_row5_desc2', 'type1_row2_image1', 'type1_row4_image1', 'type1_row4_image2', 'type1_row4_image3', 'type1_row5_image1', 'type1_row5_image2', 'type2_row1_headline' , 'type2_row1_desc' , 'type2_address' , 'type2_map' , 'type2_map2' , 'type2_info1' , 'type2_info2' , 'type2_info3' , 'type2_row2_image' , 'type2_row3_image1' , 'type2_row3_image2' , 'type2_row3_image3' , 'type2_row4_image' , 'type3_row1_headline' , 'type3_row2_headline' , 'type3_row1_desc' , 'type3_row2_desc' , 'type3_row2_image' ,'menu1_type' , 'menu2_type', 'map_type');
  foreach ($cf_keys as $cf_key) {
    $old = get_post_meta($post_id, $cf_key, true);

    if (isset($_POST[$cf_key])) {
      $new = $_POST[$cf_key];
    } else {
      $new = '';
    }

    if ($new && $new != $old) {
      update_post_meta($post_id, $cf_key, $new);
    } elseif ('' == $new && $old) {
      delete_post_meta($post_id, $cf_key, $old);
    }
  }

}
add_action('save_post', 'save_custom_fields_meta_box');


/* フォーム用 画像フィールド出力 */
function mlcf_media_form($cf_key, $label) {
	global $post;
	if (empty($cf_key)) return false;
	if (empty($label)) $label = $cf_key;

	$media_id = get_post_meta($post->ID, $cf_key, true);
?>
  <div class="cf cf_media_field hide-if-no-js <?php echo esc_attr($cf_key); ?>">
    <input type="hidden" class="cf_media_id" name="<?php echo esc_attr($cf_key); ?>" id="<?php echo esc_attr($cf_key); ?>" value="<?php echo esc_attr($media_id); ?>" />
    <div class="preview_field"><?php if ($media_id) the_mlcf_image($post->ID, $cf_key); ?></div>
    <div class="buttton_area">
     <input type="button" class="cfmf-select-img button" value="<?php _e('Select Image', 'tcd-w'); ?>" />
     <input type="button" class="cfmf-delete-img button<?php if (!$media_id) echo ' hidden'; ?>" value="<?php _e('Remove Image', 'tcd-w'); ?>" />
    </div>
  </div>
<?php
}




/* 画像フィールドで選択された画像をimgタグで出力 */
function the_mlcf_image($post_id, $cf_key, $image_size = 'medium') {
	echo get_mlcf_image($post_id, $cf_key, $image_size);
}

/* 画像フィールドで選択された画像をimgタグで返す */
function get_mlcf_image($post_id, $cf_key, $image_size = 'medium') {
	global $post;
	if (empty($cf_key)) return false;
	if (empty($post_id)) $post_id = $post->ID;

	$media_id = get_post_meta($post_id, $cf_key, true);
	if ($media_id) {
		return wp_get_attachment_image($media_id, $image_size, $image_size);
	}

	return false;
}

/* 画像フィールドで選択された画像urlを返す */
function get_mlcf_image_url($post_id, $cf_key, $image_size = 'medium') {
	global $post;
	if (empty($cf_key)) return false;
	if (empty($post_id)) $post_id = $post->ID;

	$media_id = get_post_meta($post_id, $cf_key, true);
	if ($media_id) {
		$img = wp_get_attachment_image_src($media_id, $image_size);
		if (!empty($img[0])) {
			return $img[0];
		}
	}

	return false;
}

/* 画像フィールドで選択されたメディアのURLを出力 */
function the_mlcf_media_url($post_id, $cf_key) {
	echo get_mlcf_media_url($post_id, $cf_key);
}

/* 画像フィールドで選択されたメディアのURLを返す */
function get_mlcf_media_url($post_id, $cf_key) {
	global $post;
	if (empty($cf_key)) return false;
	if (empty($post_id)) $post_id = $post->ID;

	$media_id = get_post_meta($post_id, $cf_key, true);
	if ($media_id) {
		return wp_get_attachment_url($media_id);
	}

	return false;
}


